#include "TDA7439.h"


TDA7439::TDA7439(){
 char i2c_device[15] = "/dev/i2c-1";
 int i2c_addr = 0x44;

 // open device on /dev/i2c-1 the default on Raspberry Pi B
 if ((fd = open(i2c_device, O_RDWR)) < 0) {
    printf("Error: Couldn't open device! %d\n", fd);
     //return 1;
  }

  // connect to TDA7439 as i2c slave
  if (ioctl(fd, I2C_SLAVE, i2c_addr) < 0) {
    printf("Error: Couldn't find device on address!\n");
    //return 1;
  }

   printf("Starting %s address %#02x \n",i2c_device,i2c_addr);

}

void TDA7439::setInput(int input){
  switch (input) {
    case 1: input = TDA7439_input_1;break;
	case 2: input = TDA7439_input_2;break;
	case 3: input = TDA7439_input_3;break;
	case 4: input = TDA7439_input_4;break;
  }
  writeWire(TDA7439_input_sel,input);	
  } 

void TDA7439::inputGain(int gain){
  writeWire(TDA7439_input_gain,gain);
}

void TDA7439::setVolume(int volume){
  if (volume == 0){
    volume = TDA7439_mute;
	}else{
	  volume = 48 - volume;
  }
  writeWire(TDA7439_volume,volume);
}

void TDA7439::setSnd(int val, int range){
  switch (range){
    case 1:range = TDA7439_bass;break;
	case 2:range = TDA7439_middle;break;
	case 3:range = TDA7439_trebble;break;
  }
  switch (val){
    case -7:val = 0;break;
	case -6:val = 1;break;
	case -5:val = 2;break;
	case -4:val = 3;break;
	case -3:val = 4;break;
	case -2:val = 5;break;
	case -1:val = 6;break;
	case 0 :val = 7;break;
	case 1 :val = 14;break;
	case 2 :val = 13;break;
	case 3 :val = 12;break;
	case 4 :val = 11;break;
	case 5 :val = 10;break;
	case 6 :val = 9;break;
	case 7 :val = 8;break;
  }
	  
writeWire(range,val);
}

void TDA7439::mute(){
  writeWire(TDA7439_volume,TDA7439_mute);
}

void TDA7439::spkAtt(int att_l,int att_r){
  // Mainly used to override the default attenuation of mute at power up
  writeWire(TDA7439_ratt,att_r);
  writeWire(TDA7439_latt,att_l);
}

void TDA7439::writeWire(char a, char b){
  unsigned char  buffer[2];
  buffer[0] = a; 
  buffer[1] = b; 
  write(fd, buffer,  2);

}

